import re
import sys

from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate

rules = []
meta_types = ['Page Template', 'Filesystem Page Template']

cookCache = {}

def cook(obj):
    # not sure if we need to do this or not, seems to work for me...
    # thanks Alan Runyan!
    if obj.meta_type == 'Filesystem Page Template':
        _id = obj.absolute_url(1)
        if not cookCache.has_key(_id):
            print "Cooking", _id
            z = ZopePageTemplate(obj.id,  text=obj.document_src())
            cookCache[_id] = z
        return cookCache[_id]
        
    if obj._v_cooked == 0:
        obj._cook()
    return obj

###############################################

def errors(obj):
    i = [
        'Compilation failed',
        ]
    obj = cook(obj)
    if obj._v_errors:
        return [ e for e in obj._v_errors if e not in i ]
    return 1

rules.append(
    {
        'name':'Builtin Errors',
        'meta_type':meta_types,
        'level':1,
        'function':errors,
        'msg':'Errors generated by the standard PageTemplate code',
    },
    )

###############################################

def warnings(obj):
    obj = cook(obj)
    if obj._v_warnings:
        return obj._v_warnings
    return 1

rules.append(
    {
        'name':'Builtin Warnings',
        'meta_type':meta_types,
        'level':0,
        'function':warnings,
        'msg':'Warnings generated by the standard PageTemplate code'
    },
    )


# Based on Geoff Davis ZPT tidy script
# for Plone
try:
    from mx.Tidy import tidy
    haveTidy = 1
except ImportError:
    haveTidy = 0

if haveTidy:
    from StringIO import StringIO
    
    i = [
        'unknown attribute "xmlns:metal"',
        'unknown attribute "xmlns:tal"',
        'unknown attribute "xmlns:i18n"',
    
        '<tal:block> is not recognized',
        '<metal:block> is not recognized',
        'tal:block is not recognized',
        'metal:block is not recognized',
    
        '<html> has XML attribute "xml:lang"',
        'inserting missing \'title\' element',
        'discarding unexpected ',
        'trimming empty ',
    
        'This document has errors that must be fixed before',
        'using HTML Tidy to generate a tidied up version.',
    ]
 
    unRe = re.compile('unknown attribute "(tal|metal|i18n):')
    
    def tidyObj(obj):
        obj = cook(obj)
        data = obj.document_src()
        (nerrors, nwarnings, outputdata, errordata) = tidy(
                        data, 
                        output_markup=0
                        quiet=1
                        )
        if errordata:
            newList = []
            for l in errordata.split('\n'):
                l = l.strip()
                # ignore blanks
                if not l: continue
                # loop through each error checking
                # to see if its there
                # thanks Alan Runyan
                f = [s for s in i if l.find(s) > -1]
                # ignore
                if f: continue
                # re ignore
                if unRe.search(l): continue
                # finally add
                newList.append(l)

            if newList: return newList

        return 1            

    rules.append(
    {
        'name':'HTML Tidy checks',
        'meta_type':meta_types,
        'level':0,
        'function':tidyObj,
        'msg':'Errors and warnings generated by HTML Tidy'
    }
    )
